; Tiny program to make Clipper happy even with bad network
; printer drivers. An idea of Alain. Public domain. Could
; be optimized a lot, to use less memory. However, already
; far better than using a C program :-). By Eric Auer.

; I am thinking of: if ah==02h, call old int17, and returned value
; with 0xBF and return.

	org 0x100
start:	jmp short install

i17:	cmp ah,2	; status?
	jnz oldint
	cmp dx,0	; 1st printer?
	jnz oldint
	pushf
	call far [cs:oldvec]	; call original one
	and ah,0xbf	; clear "ack bit"
	iret
oldint:	jmp far [cs:oldvec]	; jump to original one
oldvec	dd 0

install:
	mov es,[cs:0x2c]        ; environment segment
	; see Ralf Browns IntList table 1379 (PSP: 1378)
	mov ah,0x49
	int 0x21		; free the environment!
				; (jc "could not free... bla")
	push cs                 ; set segments to sane again
	pop es
	push cs
	pop ds

	mov ax,0x3517	; get printer interrupt vector
	int 0x21
	mov [ds:oldvec],bx
	mov [ds:oldvec+2],es

	push cs
	pop es		; re-set ES to CS, better style...

	mov ax,0x2517	; set printer interrupt vector
	; "mov ds,cs"	; not needed for .com :-)
	mov dx,i17	; our new interrupt handler
	int 0x21

	mov dx,helloworld
	mov ah,9	; print string
	int 0x21

	mov dx,oldvec+4+15
	shr dx,1	; convert rounded up end of TSR to
	shr dx,1	; paragraphs for the DOS go TSR call
	shr dx,1	; (divide by 16, or better,
	shr dx,1	; shift right by 4)
	mov ax,0x3100	; go TSR
	int 0x21

helloworld	db "Driver to clamp the ack status bit of "
		db "LPT1 to 0 is now installed",13,10,"$"

